<?xml version="1.0" encoding="UTF-8"?>
 <!--Multiple camera strategy config table-->
 <MultiCameraConfigTable>


    <rule name = "ZOOM OUT">
        <condition name = "TOUCH_ZOOM_STATUS" value = "ZOOM_OUT"/>
        <outState>
            <camera name = "ultra_wide" prev = "true"/>
        </outState>

        <!-- from 1.0 - 2.5 to 0.1 - 1.0  -->
        <rule name = "ZOOM OUT FROM[1.0:2.5) TO[0.1:1.0)--">
            <condition name = "ZOOM_RATIO_BEGIN" min = "1.0" max = "2.5"/>
            <condition name = "ZOOM_RATIO_END" min = "0.1" max = "1.0"/>
            <outState>
                <camera name = "ultra_wide" prev = "true"/>
            </outState>

            <!-- 1.0 - 2.5 -->
            <rule name = "ZOOM OUT FROM[1.0:2.5) TO[0.1:1.0) CUR[1.0:2.5) BEGIN(ultra_wide)">
                <condition name = "ZOOM_RATIO" min = "1.0" max = "2.5"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                </outState>

                <rule name = "ZOOM OUT FROM[1.0:2.5) TO[0.1:1.0) CUR[1.0:2.5) BEGIN(wide) NORMAL">
                    <condition name = "TOUCH_ZOOM_BEGIN_PREVIEW" value = "wide"/>
                    <outState>
                        <camera name = "wide" prev = "true"/>
                        <camera name = "ultra_wide"/>
                    </outState>
                </rule>

                <rule name = "ZOOM OUT FROM[1.0:2.5) TO[0.1:1.0) CUR[1.0:2.5) BEGIN(ultra_wide) NORMAL">
                    <condition name = "TOUCH_ZOOM_BEGIN_PREVIEW" value = "ultra_wide"/>
                    <outState>
                        <camera name = "ultra_wide" prev = "true"/>
                    </outState>
                </rule>
            </rule>

            <!-- 0.1 - 1.0 -->
            <rule name = "ZOOM OUT FROM[1.0:2.5) TO[0.1:1.0) CUR[0.1:1.0) NORMAL">
                <condition name = "ZOOM_RATIO" min = "0.1" max = "1.0"/>
                <outState>
                    <camera name = "ultra_wide" prev = "true"/>
                </outState>
            </rule>
        </rule>

        <!-- from 2.5 - inf to 0.1 - 1.0  -->
        <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[0.1:1.0)">
            <condition name = "ZOOM_RATIO_BEGIN" min = "2.5" max = "1000.0"/>
            <condition name = "ZOOM_RATIO_END" min = "0.1" max = "1.0"/>
            <outState>
                <camera name = "ultra_wide" prev = "true"/>
            </outState>

            <!-- 2.5 - inf -->
            <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[0.1:1.0) CUR[2.5:1000.0)">
                <condition name = "ZOOM_RATIO" min = "2.5" max = "1000.0"/>
                <outState>
                    <camera name = "tele" prev = "true"/>
                </outState>

                <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[0.1:1.0) CUR[2.5:1000.0) BEGIN(tele) NORMAL">
                    <condition name = "TOUCH_ZOOM_BEGIN_PREVIEW" value = "tele"/>
                    <outState>
                        <camera name = "tele" prev = "true"/>
                        <camera name = "wide"/>
                    </outState>
                </rule>

                <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[0.1:1.0) CUR[2.5:1000.0) BEGIN(wide) NORMAL">
                    <condition name = "TOUCH_ZOOM_BEGIN_PREVIEW" value = "wide"/>
                    <outState>
                        <camera name = "wide" prev = "true"/>
                        <camera name = "ultra_wide"/>
                    </outState>
                </rule>
            </rule>

            <!-- <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[0.1:1.0) CUR[1.0:2.5)">
                <condition name = "ZOOM_RATIO" min = "1.8" max = "2.5"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                </outState>
            </rule> -->

            <!-- 1.0 - 2.5 -->
            <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[0.1:1.0) CUR[1.0:2.5) NORMAL">
                <condition name = "ZOOM_RATIO" min = "1.0" max = "2.5"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                    <camera name = "ultra_wide"/>
                </outState>
            </rule>

            <!-- 0.1 - 1.0 -->
            <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[0.1:1.0) CUR[0.1:1.0) NORMAL">
                <condition name = "ZOOM_RATIO" min = "0.1" max = "1.0"/>
                <outState>
                    <camera name = "ultra_wide" prev = "true"/>
                </outState>
            </rule>
        </rule>

        <!-- from 2.5 - inf to 1.0 - 2.5  -->
        <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[1.0:2.5)">
            <condition name = "ZOOM_RATIO_BEGIN" min = "2.5" max = "1000.0"/>
            <condition name = "ZOOM_RATIO_END" min = "1.0" max = "2.5"/>
            <outState>
                <camera name = "wide" prev = "true"/>
            </outState>

            <!-- 2.5 - inf -->
            <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[1.0:2.5) CUR[2.5:1000.0)">
                <condition name = "ZOOM_RATIO" min = "2.5" max = "1000.0"/>
                <outState>
                    <camera name = "tele" prev = "true"/>
                    <camera name = "wide"/>
                </outState>

                <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[1.0:2.5) CUR[2.5:1000.0) BEGIN(tele)">
                    <condition name = "TOUCH_ZOOM_BEGIN_PREVIEW" value = "tele"/>
                    <outState>
                        <camera name = "tele" prev = "true"/>
                        <camera name = "wide"/>
                    </outState>
                </rule>

                <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[1.0:2.5) CUR[2.5:1000.0) BEGIN(wide)">
                    <condition name = "TOUCH_ZOOM_BEGIN_PREVIEW" value = "wide"/>
                    <outState>
                        <camera name = "wide" prev = "true"/>
                        <camera name = "ultra_wide"/>
                    </outState>
                </rule>
            </rule>

            <!-- 2.0 - 2.5 -->
            <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[1.0:2.5) CUR[1.0:2.5)">
                <condition name = "ZOOM_RATIO" min = "1.001" max = "2.5"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                    <camera name = "ultra_wide"/>
                </outState>
            </rule>

            <!-- 1.0 -->
            <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[1.0:2.5) CUR[1.0:2.5)">
                <condition name = "ZOOM_RATIO" min = "1.0" max = "1.001"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                </outState>

                <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[1.0:2.5) CUR[1.0) END(wide)">
                    <condition name = "TOUCH_ZOOM_END_PREVIEW" value = "wide"/>
                    <outState>
                        <camera name = "wide" prev = "true"/>
                    </outState>
                </rule>

                <rule name = "ZOOM OUT FROM[2.5:1000.0) TO[1.0:2.5) CUR[1.0) END(ultra_wide)">
                    <condition name = "TOUCH_ZOOM_END_PREVIEW" value = "ultra_wide"/>
                    <outState>
                        <camera name = "ultra_wide" prev = "true"/>
                        <camera name = "wide"/>
                    </outState>
                </rule>
            </rule>

        </rule>

        <!--in 0.1 - 1.0 -->
        <rule name = "ZOOM OUT FROM[0.1:1.0) TO[0.1:1.0)">
            <condition name = "ZOOM_RATIO_BEGIN" min = "0.1" max = "1.0"/>
            <condition name = "ZOOM_RATIO_END" min = "0.1" max = "1.0"/>
            <outState>
                <camera name = "ultra_wide" prev = "true"/>
            </outState>
        </rule>

        <!--in 1.0 - 2.5 -->
        <rule name = "ZOOM OUT FROM[1.0:2.5) TO[1.0:2.5)">
            <condition name = "ZOOM_RATIO_BEGIN" min = "1.0" max = "2.5"/>
            <condition name = "ZOOM_RATIO_END" min = "1.0" max = "2.5"/>
            <outState>
                <camera name = "wide" prev = "true"/>
            </outState>

            <rule name = "ZOOM OUT FROM[1.0:2.5) TO[1.0:2.5) CUR[1.001:2.5)">
                <condition name = "ZOOM_RATIO" min = "1.001" max = "2.5"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                    <camera name = "ultra_wide"/>
                </outState>
            </rule>

            <rule name = "ZOOM OUT FROM[1.0:2.5) TO[1.0:2.5) CUR[1.0)">
                <condition name = "ZOOM_RATIO" min = "1.0" max = "1.001"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                </outState>

                <rule name = "ZOOM OUT FROM[1.0:2.5) TO[1.0:2.5) CUR[1.0) END(wide)">
                    <condition name = "TOUCH_ZOOM_END_PREVIEW" value = "wide"/>
                    <outState>
                        <camera name = "wide" prev = "true"/>
                    </outState>
                </rule>

                <rule name = "ZOOM OUT FROM[1.0:2.5) TO[1.0:2.5) CUR[1.0) END(ultra_wide)">
                    <condition name = "TOUCH_ZOOM_END_PREVIEW" value = "ultra_wide"/>
                    <outState>
                        <camera name = "ultra_wide" prev = "true"/>
                        <camera name = "wide"/>
                    </outState>
                </rule>
            </rule>

        </rule>

        <!--in 2.5 - inf -->
        <rule name = "ZOOM IN FROM[0.1:1.0) TO[0.1:1.0)">
            <condition name = "ZOOM_RATIO_BEGIN" min = "2.5" max = "1000.0"/>
            <condition name = "ZOOM_RATIO_END" min = "2.5" max = "1000.0"/>
            <outState>
                <camera name = "tele" prev = "true"/>
            </outState>
        </rule>
    </rule>

    <rule name = "ZOOM IN">
        <condition name = "TOUCH_ZOOM_STATUS" value = "ZOOM_IN"/>
        <outState>
            <camera name = "ultra_wide" prev = "true"/>
        </outState>

        <!-- form 0.1 - 1.0 to 1.0 - 2.5 -->
        <rule name = "ZOOM IN FROM[0.1:1.0) TO[1.0:2.5)">
            <condition name = "ZOOM_RATIO_BEGIN" min = "0.1" max = "1.0"/>
            <condition name = "ZOOM_RATIO_END" min = "1.0" max = "2.5"/>
            <outState>
                <camera name = "ultra_wide" prev = "true"/>
            </outState>

            <!-- [0.1 - 1.0) -->
            <rule name = "ZOOM IN FROM[0.1:1.0) TO[1.0:2.5) CUR[0.1:1.0)">
                <condition name = "ZOOM_RATIO" min = "0.1" max = "1.0"/>
                <outState>
                    <camera name = "ultra_wide" prev = "true"/>
                    <camera name = "wide"/>
                </outState>
            </rule>

            <!-- [1.0 - 1.001) -->
            <rule name = "ZOOM IN FROM[0.1:1.0) TO[1.0:2.5) CUR[1.0:1.001)">
                <condition name = "ZOOM_RATIO" min = "1.0" max = "1.001"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                </outState>

                <rule name = "ZOOM IN FROM[0.1:1.0) TO[1.0:2.5) CUR[1.0:1.001) END(wide)">
                    <condition name = "TOUCH_ZOOM_END_PREVIEW" value = "wide"/>
                    <outState>
                        <camera name = "wide" prev = "true"/>
                    </outState>
                </rule>
    
                <rule name = "ZOOM IN FROM[0.1:1.0) TO[1.0:2.5) CUR[1.0:1.001) END(tele)">
                    <condition name = "TOUCH_ZOOM_END_PREVIEW" value = "ultra_wide"/>
                    <outState>
                        <camera name = "ultra_wide" prev = "true"/>
                        <camera name = "wide"/>
                    </outState>
                </rule>
            </rule>

            <!-- [1.001 - 2.5) -->
            <rule name = "ZOOM IN FROM[0.1:1.0) TO[1.0:2.5) CUR[1.001:2.5)">
                <condition name = "ZOOM_RATIO" min = "1.001" max = "2.5"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                </outState>
            </rule>
        </rule>

        <!-- form 0.1 - 1.0 to 2.5 - inf -->
        <rule name = "ZOOM IN FROM[0.1:1.0) TO[2.5:1000.0)">
            <condition name = "ZOOM_RATIO_BEGIN" min = "0.1" max = "1.0"/>
            <condition name = "ZOOM_RATIO_END" min = "2.5" max = "1000.0"/>
            <outState>
                <camera name = "ultra_wide" prev = "true"/>
            </outState>

            <!-- [0.1 - 1.0) -->
            <rule name = "ZOOM IN FROM[0.1:1.0) TO[2.5:1000.0) CUR[0.1:1.0)">
                <condition name = "ZOOM_RATIO" min = "0.1" max = "1.0"/>
                <outState>
                    <camera name = "ultra_wide" prev = "true"/>
                    <camera name = "wide"/>
                </outState>
            </rule>

            <!-- [0.1 - 1.3) -->
            <!-- <rule name = "ZOOM IN FROM[0.1:1.0) TO[2.5:1000.0) CUR[1.0:2.5) ">
                <condition name = "ZOOM_RATIO" min = "1.0" max = "1.3"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                </outState>
            </rule> -->

            <!-- [1.0 - 2.5) -->
            <rule name = "ZOOM IN FROM[0.1:1.0) TO[2.5:1000.0) CUR[1.0:2.5) ">
                <condition name = "ZOOM_RATIO" min = "1.0" max = "2.5"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                    <camera name = "tele"/>
                </outState>
            </rule>

            <!-- [2.5 - inf) -->
            <rule name = "ZOOM IN FROM[0.1:1.0) TO[2.5:1000.0) CUR[2.5:1000.0) END(wide)">
                <condition name = "ZOOM_RATIO" min = "2.5" max = "1000.0"/>
                <condition name = "TOUCH_ZOOM_END_PREVIEW" value = "wide"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                </outState>
            </rule>

            <rule name = "ZOOM IN FROM[0.1:1.0) TO[2.5:1000.0) CUR[2.5:1000.0) END(tele)">
                <condition name = "ZOOM_RATIO" min = "2.5" max = "1000.0"/>
                <condition name = "TOUCH_ZOOM_END_PREVIEW" value = "tele"/>
                <outState>
                    <camera name = "tele" prev = "true"/>
                </outState>
            </rule>
        </rule>

        <!-- form 1.0 - 2.5 to 2.5 - inf -->
        <rule name = "ZOOM IN FROM[1.0:2.5) TO[2.5:1000.0)">
            <condition name = "ZOOM_RATIO_BEGIN" min = "1.0" max = "2.5"/>
            <condition name = "ZOOM_RATIO_END" min = "2.5" max = "100.0"/>
            <outState>
                <camera name = "wide" prev = "true"/>
            </outState>

            <!-- [1.0 - 2.5) -->
            <rule name = "ZOOM IN FROM[1.0:2.5) TO[2.5:1000.0) CUR[1.0:2.5) BEGIN(ultra_wide)">
                <condition name = "ZOOM_RATIO" min = "1.0" max = "2.5"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                </outState>

                <rule name = "ZOOM IN FROM[1.0:2.5) TO[2.5:1000.0) CUR[1.0:2.5) BEGIN(ultra_wide) N">
                    <condition name = "TOUCH_ZOOM_BEGIN_PREVIEW" value = "ultra_wide"/>
                    <outState>
                        <camera name = "ultra_wide" prev = "true"/>
                        <camera name = "wide"/>
                    </outState>
                </rule>
                <rule name = "ZOOM IN FROM[1.0:2.5) TO[2.5:1000.0) CUR[1.0:2.5) BEGIN(wide) N">
                    <condition name = "TOUCH_ZOOM_BEGIN_PREVIEW" value = "wide"/>
                    <outState>
                        <camera name = "wide" prev = "true"/>
                        <camera name = "tele"/>
                    </outState>
                </rule>
            </rule>

            <!-- [2.5 - inf) -->
            <rule name = "ZOOM IN FROM[1.0:2.5) TO[2.5:1000.0) CUR[2.5:1000.0) END(wide)">
                <condition name = "ZOOM_RATIO" min = "2.5" max = "1000.0"/>
                <outState>
                    <camera name = "tele" prev = "true"/>
                </outState>

                <rule name = "ZOOM IN FROM[1.0:2.5) TO[2.5:1000.0) CUR[2.5:1000.0) END(wide) N">
                    <condition name = "TOUCH_ZOOM_END_PREVIEW" value = "wide"/>
                    <outState>
                        <camera name = "wide" prev = "true"/>
                    </outState>
                </rule>
                <rule name = "ZOOM IN FROM[1.0:2.5) TO[2.5:1000.0) CUR[2.5:1000.0) END(tele) N">
                    <condition name = "TOUCH_ZOOM_END_PREVIEW" value = "tele"/>
                    <outState>
                        <camera name = "tele" prev = "true"/>
                    </outState>
                </rule>
            </rule>

        </rule>

        <!-- in 0.1 - 1.0  -->
        <rule name = "ZOOM IN FROM[0.1:1.0) TO[0.1:1.0)">
            <condition name = "ZOOM_RATIO_BEGIN" min = "0.1" max = "1.0"/>
            <condition name = "ZOOM_RATIO_END" min = "0.1" max = "1.0"/>
            <outState>
                <camera name = "ultra_wide" prev = "true"/>
                <camera name = "wide"/>
            </outState>
        </rule>

        <!-- in 1.0 - 2.5  -->
        <rule name = "ZOOM IN FROM[1.0:2.5) TO[1.0:2.5)">
            <condition name = "ZOOM_RATIO_BEGIN" min = "1.0" max = "2.5"/>
            <condition name = "ZOOM_RATIO_END" min = "1.0" max = "2.5"/>
            <outState>
                <camera name = "wide" prev = "true"/>
            </outState>

            <!-- 1.0 - 2.0 -->
            <rule name = "ZOOM IN FROM[1.0:2.5) TO[1.0:2.5) CUR[1.0:2.0)">
                <condition name = "ZOOM_RATIO" min = "1.0" max = "2.0"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                </outState>

                <rule name = "ZOOM IN FROM[1.0:2.5) TO[1.0:2.5) CUR[1.0:2.0) BEGIN(ultra_wide)">
                    <condition name = "TOUCH_ZOOM_BEGIN_PREVIEW" value = "ultra_wide"/>
                    <outState>
                        <camera name = "ultra_wide" prev = "true"/>
                        <camera name = "wide"/>
                    </outState>
                </rule>

                <rule name = "ZOOM IN FROM[1.0:2.5) TO[1.0:2.5) CUR[1.0:2.0) BEGIN(wide)">
                    <condition name = "TOUCH_ZOOM_BEGIN_PREVIEW" value = "wide"/>
                    <outState>
                        <camera name = "wide" prev = "true"/>
                    </outState>
                </rule>
            </rule>

            <!-- 2.0 - 2.5 -->
            <rule name = "ZOOM IN FROM[1.0:2.5) TO[1.0:2.5) CUR[2.0:2.5)">
                <condition name = "ZOOM_RATIO" min = "2.0" max = "2.5"/>
                <outState>
                    <camera name = "wide" prev = "true"/>
                </outState>
            </rule>
        </rule>

        <!-- in 2.5 - inf  -->
        <rule name = "ZOOM IN FROM[1.0:2.5) TO[2.5:1000.0)">
            <condition name = "ZOOM_RATIO_BEGIN" min = "2.5" max = "1000.0"/>
            <condition name = "ZOOM_RATIO_END" min = "2.5" max = "1000.0"/>
            <outState>
                <camera name = "tele" prev = "true"/>
            </outState>
        </rule>

    </rule>
 </MultiCameraConfigTable>
